#ifndef OBJECTIVE_UI_HPP
#define OBJECTIVE_UI_HPP

#include "godot_cpp/classes/check_box.hpp"
#include "godot_cpp/classes/object.hpp"
#include "godot_cpp/classes/packed_scene.hpp"
#include "objective_flags.hpp"
#include <godot_cpp/templates/hash_map.hpp>
#include <godot_cpp/classes/v_box_container.hpp>

namespace gd = godot;

class ObjectiveUI : public gd::VBoxContainer {
	GDCLASS(ObjectiveUI, gd::VBoxContainer);
	static void _bind_methods();
public:
	virtual void _ready() override;
private:
	void build_ui_from(gd::Ref<ObjectiveData> data);
	void build_ui_element_for(gd::Ref<ObjectiveData> data);
	void clear_ui();
	void objective_progress(gd::Ref<ObjectiveData> data);
	void objectives_changed();
public:
	void set_objective_element_scene(gd::Ref<gd::PackedScene> scene);
	gd::Ref<gd::PackedScene> get_objective_element_scene();
public:
	gd::HashMap<gd::Ref<ObjectiveData>, gd::CheckBox*> display_elements{};
	gd::Ref<gd::PackedScene> objective_element_scene{};
	ObjectiveFlags *flags{nullptr};
};

#endif // !OBJECTIVE_UI_HPP
